package com.glxp.api.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inout.IOOrderStatusDao;
import com.glxp.api.admin.entity.inout.IOOrderStatusEntity;
import com.glxp.api.admin.req.inout.OrderStatusFilterRequest;
import com.glxp.api.admin.service.inout.IOOrderStatusService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class IOOrderStatusServiceImpl implements IOOrderStatusService {


    @Resource
    IOOrderStatusDao ioOrderStatusDao;


    @Override
    public IOOrderStatusEntity findByOrderId(String orderId) {
        OrderStatusFilterRequest orderStatusFilterRequest = new OrderStatusFilterRequest();
        orderStatusFilterRequest.setOrderId(orderId);
        List<IOOrderStatusEntity> orderStatusEntities = ioOrderStatusDao.filterOrderStatus(orderStatusFilterRequest);
        if (orderStatusEntities != null && orderStatusEntities.size() > 0) {
            return orderStatusEntities.get(0);
        }
        return null;
    }

    @Override
    public List<IOOrderStatusEntity> filterOrderStatus(OrderStatusFilterRequest orderStatusFilterRequest) {
        if (orderStatusFilterRequest == null) {
            return Collections.emptyList();
        }
        if (orderStatusFilterRequest.getPage() != null) {
            int offset = (orderStatusFilterRequest.getPage() - 1) * orderStatusFilterRequest.getLimit();
            PageHelper.offsetPage(offset, orderStatusFilterRequest.getLimit());
        }
        return ioOrderStatusDao.filterOrderStatus(orderStatusFilterRequest);
    }

    @Override
    public boolean insertOrderStatus(IOOrderStatusEntity ioOrderStatusEntity) {
        return ioOrderStatusDao.insertOrderStatus(ioOrderStatusEntity);
    }

    @Override
    public boolean deleteByOrderId(String orderId) {
        return ioOrderStatusDao.deleteByOrderId(orderId);
    }

    @Override
    public boolean updateOrderStatus(IOOrderStatusEntity ioOrderStatusEntity) {
        return ioOrderStatusDao.updateOrderStatus(ioOrderStatusEntity);
    }
}
