package com.glxp.api.admin.service.thrsys.impl;

import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.StrUtil;
import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrProductsExportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrProductsExportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrProductsExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrProductsExportLogServiceImpl implements ThrProductsExportLogService {
    @Resource
    ThrProductsExportLogDao thrProductsExportLogDao;

    @Override
    public ThrProductsExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<ThrProductsExportLogEntity> data = thrProductsExportLogDao.filterThrProductsExportLog(filterUdiEpLogRequest);
        if (data != null) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<ThrProductsExportLogEntity> filterThrProductsExportLog(FilterUdiEpLogRequest filterUdiEpLogRequest) {
        if (filterUdiEpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiEpLogRequest.getPage() != null) {
            int offset = (filterUdiEpLogRequest.getPage() - 1) * filterUdiEpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiEpLogRequest.getLimit());
        }
        List<ThrProductsExportLogEntity> data = thrProductsExportLogDao.filterThrProductsExportLog(filterUdiEpLogRequest);
        return data;
    }

    @Override
    public boolean insertThrProductsExportLog(ThrProductsExportLogEntity thrProductsExportLogEntity) {
        return thrProductsExportLogDao.insertThrProductsExportLog(thrProductsExportLogEntity);
    }

    @Override
    public boolean updateThrProductsExportLog(ThrProductsExportLogEntity thrProductsExportLogEntity) {
        return thrProductsExportLogDao.updateThrProductsExportLog(thrProductsExportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        //删除日志同步删除文件
        String filePath = thrProductsExportLogDao.selectFilePathById(id);
        if (StrUtil.isNotBlank(filePath)) {
            FileUtil.del(filePath);
        }
        return thrProductsExportLogDao.deleteById(id);
    }
}
